//*******************************************************
//
//	NTPclock
//
//	SPI処理
//
//	2015.9.19	KAWAKAMI Yukio
//*******************************************************

#include	"hw_config.h"
#include	"main.h"
#include	"config.h"
#include	"port.h"
#include	"spi.h"


//************************************************************
//	SPI初期化
//************************************************************
void spi_init(SPI_TypeDef *spi, u16 prescaler){
	SPI_InitTypeDef		spi_st;
	GPIO_InitTypeDef	gpio_st;

	gpio_st.GPIO_Mode = GPIO_Mode_AF_PP;
	gpio_st.GPIO_Speed = GPIO_Speed_50MHz;
	if (spi == SPI1){
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_SPI1 | RCC_APB2Periph_GPIOA,
							   ENABLE);
		gpio_st.GPIO_Pin = GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7;
		GPIO_Init(GPIOA, &gpio_st);
	} else if (spi == SPI2){
		RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI2, ENABLE);
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
		gpio_st.GPIO_Pin = GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15;
		GPIO_Init(GPIOB, &gpio_st);
	} else if (spi == SPI3){
		RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI3, ENABLE);
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
		gpio_st.GPIO_Pin = GPIO_Pin_3 | GPIO_Pin_4 | GPIO_Pin_5;
		GPIO_Init(GPIOB, &gpio_st);
	} else {
		return;
	}

	spi_st.SPI_BaudRatePrescaler = prescaler;
	spi_st.SPI_CPHA = SPI_CPHA_1Edge;
	spi_st.SPI_CPOL = SPI_CPOL_Low;
	spi_st.SPI_CRCPolynomial = 7;
	spi_st.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
	spi_st.SPI_FirstBit = SPI_FirstBit_MSB;
	spi_st.SPI_Mode = SPI_Mode_Master;
	spi_st.SPI_NSS = SPI_NSS_Soft;
	spi_st.SPI_DataSize = SPI_DataSize_8b;
	SPI_Init(spi, &spi_st);
	SPI_Cmd(spi, ENABLE);
}


//************************************************************
//	SPI送信待ち
//************************************************************
void spi_wait(SPI_TypeDef *spi){

	while(spi->SR & SPI_I2S_FLAG_BSY);
}



//************************************************************
//	SPI 送受信
//************************************************************
uint8_t spi_trx(SPI_TypeDef *spi, uint8_t data){

	while(!(spi->SR & SPI_I2S_FLAG_TXE));
	spi->DR = data;
	while(!(spi->SR & SPI_I2S_FLAG_RXNE));
	return spi->DR;
}



