#
# Board Setting
#

EVAL_BOARD    	= USE_STM3210C_EVAL
MPU_MODEL		= STM32F10X_MD
SUBMODEL		= STM32F103CBT6
HSE_CLOCK 		= 8000000
HSI_VALUE		= 8000000

VECTOR_START  	= VECT_TAB_FLASH
PERIF_DRIVER    = USE_STDPERIPH_DRIVER
OS_SUPPORT		= BARE_METAL

DEFZ = $(SUBMODEL) $(EVAL_BOARD) $(MPU_DENSITY) $(PERIF_DRIVER) $(VECTOR_START)    \
	   $(USING_HOSTAGE) $(OS_SUPPORT) $(USE_EXT_SRAM) $(USE_EXT_HEAP) $(USE_EXT_SDRAM)

# Defines if Display and Font Drivers
DEFZ += $(USE_DISPLAY) $(USE_FONTSIZE) $(USE_KANJI) $(USE_TOUCH_SENCE)  $(USE_XMSTN)		\
        $(USE_JPEG_LIB) $(USE_PNG_LIB) $(USE_GIF_LIB) 
SYNTHESIS_DEFS	= $(addprefix -D,$(DEFZ)) 							\
				 -DPACK_STRUCT_END=__attribute\(\(packed\)\) 		\
				 -DALIGN_STRUCT_END=__attribute\(\(aligned\(4\)\)\) \
				 -DMPU_SUBMODEL=\"$(SUBMODEL)\"						\
				 -DAPP_VERSION=\"$(APP_VER)\"						\
				 -DHSI_VALUE=\"$(HSI_VALUE)\"	\
				 -DHSE_VALUE=$(HSE_CLOCK)UL

