#ifndef	__COM_H__
#define	__COM_H__
//*******************************************************
//
//	NTPclock
//
//	シリアルポート制御
//
//	2015.9.19	KAWAKAMI Yukio
//*******************************************************

#include	"hw_config.h"

#define	RX_BUFF_SIZE	256
#define	TX_BUFF_SIZE	256

#define	STDIO_COM		Com1

typedef struct S_COM_WORK {
	USART_TypeDef *usart;
	volatile uint8_t	ibuff[RX_BUFF_SIZE];
	volatile uint16_t	ibuff_in;
	volatile uint16_t	ibuff_out;
	volatile uint16_t	ibuff_remain;

#if TX_BUFF_SIZE > 0
	volatile uint8_t	obuff[TX_BUFF_SIZE];
	volatile uint16_t	obuff_in;
	volatile uint16_t	obuff_out;
	volatile uint16_t	obuff_remain;
#endif
} COM_WORK;

extern void putch(uint8_t c);
extern uint8_t getch(void);
extern uint8_t keypressed(void);
extern void cputs(const char *s);
extern void cgets(char *s, int bufsize);

void	init_com(COM_WORK *com, USART_TypeDef *usart, int baud);
int		check_com(COM_WORK *com);
int		read_com(COM_WORK *com);
void	write_com(COM_WORK *com, uint8_t data);
void	write_com_str(COM_WORK *com, const char *str);
void	wait_send_com(COM_WORK *com);
void	clear_buff_com(COM_WORK *com);


#endif	// __COM_H__
