#ifndef	__MAIN_H__
#define	__MAIN_H__
//*******************************************************
//
//	NTPclock
//
//	2015.12.4	KAWAKAMI Yukio
//*******************************************************

#define		VERSION			"1.1.2"
#define		BOOT_VERSION	"1.0.0"

#define		NOP		__asm__("NOP")
//#define		NOP		asm volatile("nop\n"::)
#define		WDR		IWDG->KR = 0xAAAA
#define		SLEEP	__WFI()

#define		CR		13
#define		LF		10
#define		TAB		9

#define		ON		1
#define		OFF		0

#define		EI		__enable_irq()
#define		DI		__disable_irq()

#ifndef	NULL
#define	NULL	0
#endif

#ifndef	BYTE
#define	BYTE	uint8_t
#endif

#ifndef WORD
#define	WORD	uint16_t
#endif

#ifndef	DWORD
#define	DWORD	uint32_t
#endif

#ifndef LD_WORD
#define	LD_WORD(ptr)		(WORD)(*(WORD*)(BYTE*)(ptr))
#define	LD_DWORD(ptr)		(DWORD)(*(DWORD*)(BYTE*)(ptr))
#endif


#ifdef STM32F10X_LD
  #define FLASH_PAGE_SIZE    ((uint16_t)0x400)
#elif defined STM32F10X_MD
  #define FLASH_PAGE_SIZE    ((uint16_t)0x400)
#elif defined STM32F10X_HD
  #define FLASH_PAGE_SIZE    ((uint16_t)0x800)
#elif defined STM32F10X_CL
  #define FLASH_PAGE_SIZE    ((uint16_t)0x800)  
#endif /* STM32F10X_LD */

//#define START_ADDRESS       0x08000000
#define START_ADDRESS       0x08004000

#define	APPLICATION_ADDRESS	0x08004000
#define	BOOTLOADER_ADDRESS	0x08000000


//#define	FLASH_SIZE	48*1024L
#define RAM_ADDRESS	0x20000000
#define	FLASH_SIZE	((128-16)*1024L)
#define	RAM_SIZE	(20*1024L)
#define	CONFIG_PAGE	(START_ADDRESS - FLASH_PAGE_SIZE)
#define	CONFIG_MAX_SIZE	256
#define	FLASH_CONFIG_ADDRESS	(APPLICATION_ADDRESS - CONFIG_MAX_SIZE)
#define	SP_TOP		(RAM_ADDRESS + RAM_SIZE)


#define	BKP_REG_BACKUP			BKP_DR1
#define	BKP_REG_RUNNING_TIME_L	BKP_DR2
#define	BKP_REG_RUNNING_TIME_H	BKP_DR3
#define	BKP_REG_BATTERY_TIME_L	BKP_DR4
#define	BKP_REG_BATTERY_TIME_H	BKP_DR5
#define	BKP_REG_ADJUSTED_TIME_L	BKP_DR6
#define	BKP_REG_ADJUSTED_TIME_H	BKP_DR7
#define	BKP_REG_BACKUP_TIME_L	BKP_DR8
#define	BKP_REG_BACKUP_TIME_H	BKP_DR9

void adjust_time(uint32_t now);

void init_ports(void);
void wait_ms(int ms);
void boot(void);

void job_sec_intr(void);
void job_mount(void);

uint8_t check_board(void);

#endif		// __MAIN_H__
