#ifndef	__PORT_H__
#define	__PORT_H__
//*******************************************************
//
//	NTPclock
//
//	ポート設定
//
//	2015.9.19	KAWAKAMI Yukio
//*******************************************************

// STM32
#define		GPIO_MODE_INPUT_PULLUP		0x8
#define		GPIO_MODE_INPUT_PULLDOWN	0x8
#define		GPIO_MODE_INPUT				0x4
#define		GPIO_MODE_OUTPUT			0x3
#define		GPIO_MODE_OUTPUT_OD			0x7
#define		GPIO_MODE_ADINP				0x0
#define		GPIO_MODE_ALT_PP			0xB
#define		GPIO_MODE_ALT_OD			0xF

#define		GPIO_SET_MODE(G,B,M)	G=(((G) & (~(0x0F << (B*4))))|(M << (B*4)))
#define		GPIO_SET_LOW(G,P)		((G)->BRR = P)
#define		GPIO_SET_HIGH(G,P)		((G)->BSRR = P)
#define		IS_GPIO_HIGH(G,P)		((G)->IDR & P)
#define		IS_GPIO_LOW(G,P)		(!((G)->IDR & P))

// GPIOA
#define		PIN_WUP			GPIO_Pin_1
#define		PIN_TXD2		GPIO_Pin_2
#define		PIN_RXD2		GPIO_Pin_3
#define		PIN_M_CS		GPIO_Pin_4
#define		PIN_SCK1		GPIO_Pin_5
#define		PIN_MISO1		GPIO_Pin_6
#define		PIN_MOSI1		GPIO_Pin_7
#define		PIN_LED			GPIO_Pin_8
#define		PIN_TXD1		GPIO_Pin_9
#define		PIN_RXD1		GPIO_Pin_10
#define		PIN_RST			GPIO_Pin_11

// GPIOB
#define		PIN_LED1		GPIO_Pin_0
#define		PIN_LED2		GPIO_Pin_1
#define		PIN_LED3		GPIO_Pin_2
#define		PIN_LED4		GPIO_Pin_3
#define		PIN_LED5		GPIO_Pin_4
#define		PIN_LED6		GPIO_Pin_5
#define		PIN_LED7		GPIO_Pin_6
#define		PIN_LED8		GPIO_Pin_7
#define		PIN_LED_A		GPIO_Pin_8
#define		PIN_LED_B		GPIO_Pin_9
#define		PIN_LED_C		GPIO_Pin_10
#define		PIN_LED_D		GPIO_Pin_11
#define		PIN_LED_E		GPIO_Pin_12
#define		PIN_LED_F		GPIO_Pin_13
#define		PIN_LED_G		GPIO_Pin_14
#define		PIN_LED_DP		GPIO_Pin_15

// GPIOC
#define		PIN_OSC32_IN	GPIO_Pin_14
#define		PIN_OSC32_OUT	GPIO_Pin_15

// GPIOD
#define		PIN_OSC_IN		GPIO_Pin_0
#define		PIN_OSC_OUT		GPIO_Pin_1

// A/D ch


// GPIO動作マクロ

#define		MCS_ON			GPIOA->BRR = PIN_M_CS
#define		MCS_OFF			GPIOA->BSRR = PIN_M_CS

#define		RST_ON			GPIOA->BRR = PIN_RST
#define		RST_OFF			GPIOA->BSRR = PIN_RST

#define		LED_ON			GPIOA->BSRR = PIN_LED
#define		LED_OFF			GPIOA->BRR = PIN_LED
#define		IS_LED_ON		(GPIOA->ODR & PIN_LED)

#define		SEG_OUT(x)		GPIOB->ODR = (~x << 8) & 0xFF00

#endif	// __PORT_H__
