#ifndef	__ROM_H__
#define	__ROM_H__
//*******************************************************
//
//	NTPclock
//
//	Serial Flash ROM 処理
//
//	2015.9.19	KAWAKAMI Yukio
//*******************************************************

#include "program.h"

// M25PE20
#define	ROM_PAGE_MASK	0xFFFFFF00
#define	ROM_PAGE_SIZE	0x00000100

#define	ROM_SECTOR_MASK	0xFFFF8000
#define	ROM_SECTOR_SIZE	0x00008000

#define	RESOURCE_ADRS	0x00000000
#define	RESOURCE_SIZE	0x00010000

uint8_t ROM_status(void);
void ROM_wait(void);
void ROM_read(uint32_t adrs, uint8_t *buff, uint16_t n);
void ROM_write(uint32_t adrs, uint8_t *buff, uint16_t n);
void ROM_sector_erase(uint32_t adrs);
void ROM_page_erase(uint32_t adrs);

void ROM_id(uint8_t buff[20]);


int load_resource(void);
void get_resource_data(int n, uint32_t *adrs, uint32_t *size);
int resource_gets(int rn, char *buff, int maxlen);

#endif	// __ROM_H__
