#ifndef	__RTC_H__
#define	__RTC_H__
//*******************************************************
//
//	NTPclock
//
//	RTC
//
//	2015.11.27	KAWAKAMI Yukio
//*******************************************************

#define	RTC_BACKUP_MARK	0x19D3

struct RTC_TIME {
	uint8_t	sec;
	uint8_t	min;
	uint8_t	hour;
	uint8_t	week;
	uint8_t	day;
	uint8_t	month;
	uint8_t	year;
};

void enter_stop(int tm);
void stop_to_59(int (*func)(void));

void read_RTC(struct RTC_TIME *rtc);


void init_RTC(void);
void set_RTC_int(void);
void set_RTC_cal(int cal);

uint32_t read_RTC_value(void);
void write_RTC_value(uint32_t data);

void write_backup_ram(uint16_t adrs, uint16_t data);
uint16_t read_backup_ram(uint16_t adrs);

void seccount_to_rtctime(uint32_t sec, struct RTC_TIME *rtc);
uint32_t get_seccount(struct RTC_TIME *rtc);

void set_week(struct RTC_TIME *rtc);

#endif	// __RTC_H__
