#ifndef	__WIFI_H__
#define	__WIFI_H__
//*******************************************************
//
//	NTPclock
//
//	Wifi / ESP-WROOM-02 Module
//
//	2015.9.20	KAWAKAMI Yukio
//*******************************************************

#define	WIFI_COM	Com2

#define WIFI_RES_PROMPT				1
#define	WIFI_RES_LF_NODATA			2
#define	WIFI_RES_LF					3
#define	WIFI_RES_OK					4
#define	WIFI_RES_SEND_OK			5
#define	WIFI_RES_READY				6
#define	WIFI_RES_ERROR				7
#define	WIFI_RES_SOCK_CONNECT		8
#define	WIFI_RES_SOCK_CLOSED		9
#define	WIFI_RES_NTP_CONNECT		10
#define	WIFI_RES_NTP_CLOSED			11
#define	WIFI_RES_WIFI_CONNECT		12
#define	WIFI_RES_WIFI_DISCONNECT	13

#define	WIFI_STAT_NON			0x0000
#define	WIFI_STAT_NTP			0x1000
#define	WIFI_STAT_START			0x2000
#define	WIFI_STAT_WAIT			0x3000
#define	WIFI_STAT_HTTP			0x4000
#define	WIFI_STAT_DISCONNECT	0x8000
#define	WIFI_STAT_CLOSE			0x9000
#define	WIFI_STAT_SLEEP			0xA000
#define	WIFI_STAT_ERROR			0xF000

#define	LINEFEED_NON	0
#define	LINEFEED_CR		1
#define	LINEFEED_LF		2
#define	LINEFEED_CRLF	3

#define	SOCK_BUFF_SIZE	1024
#define	SOCK_CH_N		5

#define	SOCK_HTTP	0
#define	SOCK_NTP	4

void job_wifi(void);
void init_wifi(void);

int is_http_started(void);
int is_sock_connect(int ch);
int check_sock(int ch);
int read_sock(int ch);
void write_sock(int ch, uint8_t data);
void write_sock_str(int ch, char *str);
void write_sock_bin(int ch, uint8_t *data, int len);

void send_wifi_command(const char *data, int len);

void wifi_send_preprocess(int sock, int len);
void wifi_send_data(uint8_t *data, int len);

uint16_t wifi_ntp(uint16_t stat, int res);
uint16_t wifi_connect(uint16_t stat, int res);
uint16_t wifi_sleep(uint16_t stat, int res);

uint16_t get_wifi_stat(void);

int start_ntp(void);
int start_http(void);
void start_wifi(void);

void set_sleep(int flag);

#endif	// __WIFI_H__
